#pragma once

//     _sleep()
#pragma warning(disable : 4996)

#include "_includes.h"

//====================================================
//       :
// https://www.interestprograms.ru
//     
//====================================================


void BlockingRsendRecv(int rank, int count_processes)
{
	//     float
	const int count_float = 5;

	//       float
	std::cout.precision(10);

	if (rank == 0)
	{
		if (count_processes > 1)
		{
			//        .
			float total_sum = 0.0f;

			//     . 
			MPI_Status status = {};

			//     .
			float receive_numbers[count_float] = {0.0f};

			//     .
			for (int i = 1; i < count_processes; i++)
			{
				//   =0        ,   .
				MPI_Recv(&receive_numbers, count_float, MPI_FLOAT, MPI_ANY_SOURCE, MPI_ANY_TAG, MPI_COMM_WORLD, &status);

				for (int m = 0; m < count_float; m++)
				{
					//      .
					std::cout << "Rank " << status.MPI_SOURCE << " receive_numbers[" << m  <<  "]: " << receive_numbers[m] << "\n";

					//    .
					total_sum += receive_numbers[m];
				}
				std::cout << "-------\n";
			}

			//   .
			std::cout << "Total sum=" << total_sum << "\n";
		}
	}
	else
	{
		float send_numbers[count_float] = {0.0f};
		for (int i = 0; i < count_float; i++)
		{
			send_numbers[i] = std::rand() / 3.17f;
			std::cout << "send_number[" << i << "]: " << send_numbers[i] << "\n";
		}

		//    =0  .
		MPI_Rsend(&send_numbers, count_float, MPI_FLOAT, 0, 0, MPI_COMM_WORLD);
	}
}